# ch_8_wordcloud2

# wordcloud2()  ̿  Ŭ
# http://magician-of-c.tistory.com/m/22?category=249901

library(KoNLP)
useSejongDic()

# R ϴ wordcloud Ű  wordcloud ؼ  Ŭ庸 
# wordcloud2 ̿ؼ  wordcloud δ   ִٰ ϱ  
# wordcloud2 ġϱ Ͽ. 

# wordcloud2 devtools ؼ ġؾϹǷ 
# 켱 devtools Ű ٿ   wordcloud2 Ű ٿް ȣѴ.

install.packages("devtools")
devtools::install_github("lchiffon/wordcloud2")
library(wordcloud2)

doc <- readLines(file.choose())       # ؽƮ  о ´.

# SimplePos09() Լ  ϴ ܾ ī̽Ʈ  ±׸ ٿ 
#  ǰ Ȯ  ְ ִ Լ̴.

word <- SimplePos09(doc)

# SimplePos09()  ϰ Ǹ ܾ ũ S, F, N, P, M, I, J, E, X 
#  9 · мȴ. 

#   ݴ  мϰ ʹٸ SimplePos22() Լ ϸ ǰ, 
#  ̺   мϰ ʹٸ MorphAnalyzer() Լ ϸ ȴ.

# SimplePos22() ϸ ܾ 29 · мǰ, 
# MorphAnalyzer() ϸ ׸   µ мȴ.

# ° м  忡 ܾ ߿ N(ü), P(), M(ľ) ¸ ϱ

library(stringr)

extracted <- str_match(word, '([-]+)/[NPM]')
extracted

# str_match() Լ ܾ  ¸ ϴ ˻ִ Լ̴. 
#  Լ stringr Ű ȿ ִ Լ̹Ƿ 
# stringr Ű ȣ ص Լ Ѵ.
#  ɾ Ǯϸ ѱ۷ε ܾ  
#  ±װ N Ǵ P Ǵ M ܾ ã ̴.

# ±װ ޸ ʿ Ϳ ִ  ֱ

keyword <- extracted[,2]
nouns <- keyword[!is.na(keyword)]

# ù° ɾ (5)  extracted Ϳ 
# 1 ±װ پִ ܾ ͸  2 ܾ ͵鸸  ִ ɾ̴.
# ι° ɾ ٷ    ܾ ͵ 
# ִ Ͱ  ִ ɾ̴.

#  ܾ ߰    
mergeUserDic(data.frame(c("ġ"), c("ncn")))

nouns <- sapply(doc, extractNoun, USE.NAMES=F)
nouns <- unlist(nouns)


nouns <- gsub("׷", "", nouns)
nouns <- gsub("׸", "", nouns)
nouns <- gsub("̰", "", nouns)
nouns <- gsub("", "", nouns)


# ܾ ߿ 1 ܾ ϱ
nouns <- Filter(function(x){nchar(x)>1}, nouns)

#  unlist ɾ Ǿ ִ ܾ Ʈ  Ű ɾ̴.

#  ɾ Լ  Ͽ ܾ ڼ ȮϿ
# 1 ʰ  2 ܾ ٽ  ϴ ɾ̴.

# ܾ ̺ · ٲپ ϸ鼭 ߺ ܾ ļ  Ȯϱ
wordcount <- table(nouns)

# table() Լ ͸ ̺ · ٲپܰ ÿ    ͵ 
# ϳ ġ  ľִ Լ̴.

# ܾ  1  ܾ ϰ  ܾ ϱ
wordorder <- order(wordcount, decreasing = T)

for (i in 1:length(wordorder)){
	if(wordcount[wordorder[i]]==1){
		break
	}
}

freqwords <- wordcount[wordorder[1:i-1]]
wordorder

# order() Լ ͸ ִ Լ̴. 
#  decreasing  ǾǷ  ū   ش.

# wordorder   ܾ Ͱ ƴ index ̴. 
#  wordorder  ó  6 wordcount 6°    ũٴ ǹ̴.

# Ʒ ǹ wordorder   wordcount  1 ʹ 
# ͸ ϱ ؼ  1 ۵Ǵ i  ѵ 
# wordcount[wordorder[1:i-1]] Ͽ ù° Һ i-1° ұ 
#   ش.
freqwords

# word Cloud 
wc <- wordcloud2(data=freqwords, size = 1.5, color = "random-light", backgroundColor = "grey", rotateRatio = 0.75)
wc

# wordcloud2() Լ 츮    Ŭ带 ִ Լ̴.
# wordcloud2() Լ ⺻ data  ־ָ 
#  ٸ  ⺻ Ʈ õǾ ִ.
#  ϴ , ڻ, Ʈ,    ϴ   ָ
#    Ŭ尡  ̴.
#  ڵ R Studio  ϴܿ ִ Viewer  Ʒ  ׸  ʴ´ٸ 
# console ׿ wc Է  ͸ ġ ϰ̴.
